*-------------------- VARIABLES IN COMMON ------------------------------

      integer metadim_nhill, metadim_nrc, metadim_nat
      parameter (metadim_nhill=1000000,metadim_nrc=10,metadim_nat=100)
! metadim_nhill : max number of hills 
! metadim_nrc   : max number of reaction coordinates
! metadim_nat   : max number of atoms involved in the definition of
!                 a single reaction coordinate
      INTEGER meta_n                               ! current number of hills
      INTEGER meta_step                            ! current number of steps
      INTEGER meta_nrc                             ! total number of reaction coordinates (RCs)
      INTEGER kmeta,kmetar,kmetaw                  ! output units
      INTEGER meta_atoms(metadim_nat,metadim_nrc) ! each row contains the atoms that define a RC
      REAL*8  meta_ts           ! hills deposition interval 
      REAL*8  meta_print                           ! printing interval
      REAL*8  meta_height                          ! hill heigth
      REAL*8  meta_tot          ! sum_i 1/V_i over the hills
      REAL*8  meta_maxv         ! max value of the biasing potential at current time
      REAL*8  meta_temperature  ! temperature for the tempered-well tempered metadynamics algorithm
      REAL*8  meta_rc(metadim_nrc)                 ! current position of the system in the RCs space
      REAL*8  meta_width(metadim_nrc)              ! array of the widths of an hill along each RC
      REAL*8  meta_e(metadim_nhill)                ! array of the biasing potential corresponding to the center of each of the hills
      REAL*8  meta_list(metadim_nhill,metadim_nrc) ! the i-th row is the position of the i-th hill in the RCs space
      REAL*8  meta_weight(metadim_nhill) ! array of weights for well-tempered metadynamics
      LOGICAL meta                                 ! if true, the program performs a metadynamics run
      LOGICAL meta_analysis     ! if true, the program performs a metadynamics run
      LOGICAL meta_tempered   ! if true, tempered metadynamics
      LOGICAL meta_wtempered   ! if true, well tempered metadynamics
      LOGICAL metar,metaw                          ! if true, read/print a restart file
      CHARACTER*1 meta_dc                          ! dummy character
      CHARACTER*4 meta_rctype(metadim_nrc)         ! array containing the kinds of the RCs  
      CHARACTER*80 metar_file,metaw_file
      
*-------------------- VARIABLES IN COMMON ------------------------------
      
      COMMON /metain/  meta_n, meta_step, meta_nrc, kmeta,
     &     kmetar,kmetaw,meta_atoms
      COMMON /metadp/  meta_ts, meta_print, meta_height,
     &     meta_tot, meta_maxv, meta_temperature, meta_rc, meta_width,
     &     meta_e,meta_list, meta_weight
      COMMON /metalo/  meta,meta_analysis,meta_tempered,meta_wtempered
     &     ,metar,metaw
      COMMON /metach/  meta_rctype,metar_file,metaw_file
      
