*-------------------- VARIABLES IN COMMON ------------------------------

      INTEGER rem_group(2,10)   ! matrix of the first and the last atoms of each group
      INTEGER rem_acc(100)      ! number of accepted exchanges in replica index order
      INTEGER rep_acc(100)      ! number of accepted exchanges in replica index order (for the current process)
      INTEGER rem_table(0:99)   ! array of replica indeces in processor index order 
      INTEGER para_index        ! processor index
      INTEGER rem_groups        ! total number of REM segments
      INTEGER rem_segkind       ! 1: only the segments-segments interactions are divided; 2: segments-system interactions; 0: both.
      INTEGER cdist             ! input parameter. 0: restart; 1 default temperature progression; 2 user defined temperature progression
      INTEGER step_rem          ! total REM exchanges counter 
      REAL*8  rem_mat(100,3)    ! matrix of scaling factors ordered for replica index
      REAL*8  rem_factor(3)     ! array of multiplicative scaling factor
      REAL*8  rem_pot(3)        ! array of (unscaled) potential energies (n0,n1,nb)
      REAL*8  rem_factor_max(3) ! array of maximum values of the factors
      REAL*8  rem_print         ! print interval
      REAL*8  rem_ts            ! exchange interval
      REAL*8  rem_n1_energy     ! (unscaled) torsional energy of the selected segments
      REAL*8  rem_hnb_energy    ! (unscaled) h-shell energy of the selected segments
      REAL*8  rem_lnb_energy    ! (unscaled) l-shell energy of the selected segments
      REAL*8  rem_mnb_energy    ! (unscaled) m-shell energy of the selected segments
      LOGICAL para_restart      ! if true, restart from a previous parallel run
      LOGICAL rem               ! if true, a REMD run is performed
      LOGICAL rem_segment       ! if true, only the torsional potential of the selected segments is scaled
      
*-------------------- VARIABLES IN COMMON ------------------------------
      
      COMMON /remint/ rem_group,rem_acc,rep_acc,rem_table,para_index
     &     ,rem_groups,rem_segkind, cdist, step_rem
      COMMON /remdp/  rem_mat,rem_factor,rem_pot,rem_factor_max
     &     ,rem_print,rem_ts,rem_n1_energy,rem_hnb_energy
     &     ,rem_lnb_energy,rem_mnb_energy
      COMMON /remlo/  para_restart,rem,rem_segment
      
