      subroutine mts_intra_n1(xp0,yp0,zp0,xcm,ycm,zcm,fpx,fpy,fpz
     &     ,fudge_qq,fudge_lj,fold_dir,puhyd,conf_bnd_slt,conf_bnd_slv
     &     ,coul_bnd_slt,coul_bnd_slv,unb14,cnb14,ungrp,cngrp,uptors
     &     ,uslvtor,stressd,mapdn,nmapdn,uumb,gr)

************************************************************************
*     FINTRAP call slow "bonded" force routines for the solute.   
************************************************************************

      IMPLICIT none

      include 'parst.h'

*----------------------- ARGUMENTS -------------------------------------

      REAL*8  xp0(*),yp0(*),zp0(*),xcm(*),ycm(*),zcm(*),unb14,cnb14
      REAL*8  fpx(*),fpy(*),fpz(*),stressd(3,3),puhyd,conf_bnd_slt
     &     ,conf_bnd_slv,coul_bnd_slt,coul_bnd_slv,uslvtor
      INTEGER fold_dir,nmapdn(*),mapdn(2,*) 
      REAL*8 uptors,fudge_qq,fudge_lj,ungrp,cngrp,uumb,gr

*-------------------- VARIABLES IN COMMONS -----------------------------

      include 'cpropar.h'
#ifdef PARALLEL
      include 'crem.inc'
#endif

*-------------------- LOCAL VARIABLES ----------------------------------

      REAL*8  unb14_slt,cnb14_slt,ungrp_slt,cngrp_slt,uptors_slt
     &       ,unb14_slv,cnb14_slv,ungrp_slv,cngrp_slv,uptors_slv
      REAL*8  xc,yc,zc,st(3,3)
      INTEGER i,j,i1,count,m

# ifdef PARALLEL
      rem_n1_energy = 0.0D0
#endif

*=======================================================================
*--- Zero stress tensor ------------------------------------------------
*=======================================================================

      IF(cpress .OR. pressure) THEN
         CALL zero0(stressd,9)
         CALL zero0(st,9)
      END IF
         
*=======================================================================
*----- Third neighbour interactions : Sum on the direct lattice --------
*=======================================================================
#ifdef PARALLEL
      IF(rem_segment) THEN 
        CALL fnb14_rem(ss_index,xp0,yp0,zp0,chrge,ntap,ecc1412,ecc146
     &       ,cutoff,clewld,alphal,int14,int14p,type14,fudge,lj_fudge
     &       ,fpx,fpy,fpz,unb14_slt,unb14_slv,cnb14_slt,cnb14_slv
     &       ,remint14)
      ELSE
#endif
        CALL fnb14(ss_index,xp0,yp0,zp0,chrge,ntap,ecc1412,ecc146
     &       ,cutoff,clewld,alphal,int14,int14p,type14,fudge,lj_fudge
     &       ,fpx,fpy,fpz,unb14_slt,unb14_slv,cnb14_slt,cnb14_slv)
#ifdef PARALLEL
      ENDIF
#endif
      unb14=unb14_slt
      cnb14=cnb14_slt
      
      conf_bnd_slt=unb14_slt
      coul_bnd_slt=cnb14_slt
      conf_bnd_slv=unb14_slv
      coul_bnd_slv=cnb14_slv
         
*=======================================================================
*----- Interactions between atoms contained in the same group ----------
*=======================================================================

      CALL fnbgrp(ss_index,xp0,yp0,zp0,chrge,nbtype,ecc12,ecc6,clewld
     &     ,alphal,ingrp,ingrpp,fpx,fpy,fpz,ungrp_slt,ungrp_slv
     &     ,cngrp_slt,cngrp_slv)
      ungrp=ungrp_slt
      cngrp=cngrp_slt

      conf_bnd_slt=conf_bnd_slt+ungrp_slt
      coul_bnd_slt=coul_bnd_slt+cngrp_slt
      conf_bnd_slv=conf_bnd_slv+ungrp_slv
      coul_bnd_slv=coul_bnd_slv+cngrp_slv


*=======================================================================
*----- Bonded interactions: proper torsions ----------------------------
*=======================================================================      
#ifdef PARALLEL
      IF(rem_segment) THEN
        CALL fptors_rem(ss_index,ltor,ltors,xp0,yp0,zp0,potto(1,2)
     &       ,potto(1,1),uptors_slt,uptors_slv,fpx,fpy,fpz,remltor)
      ELSE
#endif
        CALL fptors(ss_index,ltor,ltors,xp0,yp0,zp0,potto(1,2),potto(1
     &       ,1),uptors_slt,uptors_slv,fpx,fpy,fpz)
#ifdef PARALLEL
      ENDIF
#endif
      uptors =uptors_slt
      uslvtor=uptors_slv

*=======================================================================
*---- Calculate forces if umbrella on Rg is to be done -----------------
*=======================================================================

      IF(.NOT. fold) THEN
         IF(wrtgyr) THEN
            CALL mts_umbrl(abmd_unbias,fold,fold_dir,xp0,yp0,zp0,uumb
     &           ,nbone,mback,ntap,rspset,omega,spring,gr,fpx,fpy,fpz)
         END IF
      ELSE
         CALL mts_umbrl(abmd_unbias,fold,fold_dir,xp0,yp0,zp0,uumb,nbone
     &        ,mback,ntap,rspset,omega,spring,gr,fpx,fpy,fpz)
      END IF

*=======================================================================
*---- Add forces from hystory-dependent potential if present ----
*=======================================================================
      
      call meta_forces(xp0,yp0,zp0,fpx,fpy,fpz,co,oc,ntap)

*=======================================================================
*---- Compute stress tensor if coupling is by group --------------------
*=======================================================================

      IF(cpress .OR. pressure .AND. coupl_grp) THEN
         count=0
         DO i=1,nprot
            xc=xcm(i)
            yc=ycm(i)
            zc=zcm(i)
            m=protl(count+1)
            DO i1=1,m
               j=protl(count+1+i1)
               st(1,1)=st(1,1)+xc*fpx(j)
               st(1,2)=st(1,2)+yc*fpx(j)
               st(1,3)=st(1,3)+zc*fpx(j)
               st(2,1)=st(2,1)+xc*fpy(j)
               st(2,2)=st(2,2)+yc*fpy(j)
               st(2,3)=st(2,3)+zc*fpy(j)
               st(3,1)=st(3,1)+xc*fpz(j)
               st(3,2)=st(3,2)+yc*fpz(j)
               st(3,3)=st(3,3)+zc*fpz(j)
            END DO
            count=count+m+1
         END DO
         CALL DGEMM('N','T',3,3,3,1.0D0,co,3,st,3,0.0D0,stressd,3)
      END IF

      RETURN
      END
