      SUBROUTINE read_input(sitew,iret,errmsg)

*======================================================================*
*                                                                      *
*                             Last update                              *
*                                                                      *
*     $Id: read_input.f,v 1.1.1.1 2009/10/19 07:48:42 signo Exp $
*                                                                      *
*     Written by Massimo Marchi CE Saclay                              *
*                                                                      *
*                                                                      *
*     EXTERNALS : Free format input package, MAXA0.                    *
*                                                                      *
*                                                                      *
************************************************************************


!======================= DECLARATIONS ==================================

      IMPLICIT none

!----------------------- ARGUMENTS -------------------------------------

      INTEGER sitew,iret
      CHARACTER*80 errmsg

!-------------------- LOCAL VARIABLES ----------------------------------

      INTEGER nword
      LOGICAL lprint
      CHARACTER*22 err_open
      CHARACTER*37 err_args(3)
      CHARACTER*20 err_end 
      CHARACTER*27 err_unr(4)
      CHARACTER*15 err_fnf
      CHARACTER*80 line,strngs(40)
      CHARACTER*1 sep(2),comm(2)
      REAL*8  fmaxstp,fscale,fprint,fsave,fplot,fascii,fprop,fplot_fragm
     &     ,fplot_steer,fplottemp_stn0,fplot_stn0,fplot_center,frject
     &     ,fconf,fmaxrun,fupdte,fxrms,fvi,fvoronoi,ftop_print
     &     ,gofr_fprint,gofr_favg,gofr_fcomp,fprtvaf,ftotvaf,fnovaf
     &     ,fdipole,favg,favg_xrms,ffragm_dist,fhbonds,frms,fgyr,fabmd
      DATA sep/' ',','/comm/'(',')'/

!-------------------- COMMON VARIABLES ---------------------------------

      INCLUDE 'parst.h'
      INCLUDE 'cpropar.h'
      INCLUDE 'crem.inc'
      INCLUDE 'unit.h'
      COMMON /card / jrec,nrec,jerr,nerr,nline,istrt
      INTEGER jrec,nrec,jerr,nerr,nline,istrt(80)

!==================== EXECUTABLE STATEMENTS ============================

!--------------  synatx errors messages---------------------------------
!   control error messages in all envs except PARAMETERS and ANALYSIS
  
      err_open = 'OPEN keyword not found'
      err_args(1) = 'Number of arguments must be at least '
      err_args(2) = 'Number of arguments must not exceed  '
      err_args(3) = 'Number of arguments must be only     '
      err_unr(1)='Unrecognized command  ---> '
      err_unr(2)='Unrecognized subcommand -> '
      err_unr(3)='Unrecognized keyword ----> '
      err_unr(4)='UNSUPPORTED  COMMAND ----> '
      err_end = '...or missing &END'  
      err_fnf = ' file not found' 

!------------- Set default values of some input parameters -------------
      CALL blkdta
      fmaxstp=0.0D0
      fscale=0.0D0
      fprint=0.0D0
      fsave=0.0D0
      fplot=0.0D0
      fascii=0.0D0
      fprop=0.0D0
      fplot_fragm=0.0D0
      fplot_steer=0.0D0
      fplottemp_stn0=0.0D0
      fplot_center=0.0D0
      frject=0.0D0
      fconf=0.0D0
      fmaxrun=0.0D0
      fupdte=0.0D0
      fxrms=0.0D0
      fvi=0.0D0
      fvoronoi=0.0D0
      ftop_print=0.0D0
      gofr_fprint=0.0D0
      gofr_favg=0.0D0
      gofr_fcomp=0.0D0
      fprtvaf=0.0D0
      ftotvaf=0.0D0
      fnovaf=0.0D0
      fdipole=0.0D0
      favg=0.0D0
      favg_xrms=0.0D0
      ffragm_dist=0.0D0
      fhbonds=0.0D0
      frms=0.0D0
      fgyr=0.0D0

      lprint=.FALSE.
      WRITE(kprint,1)
      WRITE(kprint,2)
      WRITE(kprint,3)
      WRITE(kprint,2)
      WRITE(kprint,4)
      WRITE(kprint,2)
      WRITE(kprint,5)
      WRITE(kprint,2)
      WRITE(kprint,6)
      WRITE(kprint,2)
      WRITE(kprint,7)
      WRITE(kprint,2)
      WRITE(kprint,2)
      WRITE(kprint,2)
      WRITE(kprint,2)
      WRITE(kprint,10)
      WRITE(kprint,2)
      WRITE(kprint,11)
      WRITE(kprint,2)
      WRITE(kprint,2)
      WRITE(kprint,2)
      WRITE(kprint,12)
      WRITE(kprint,2)
      WRITE(kprint,13)
      WRITE(kprint,2)
      WRITE(kprint,2)
      WRITE(kprint,2)
      WRITE(kprint,2)
      WRITE(kprint,2)
      WRITE(kprint,2)
      WRITE(kprint,1)
      WRITE(kprint,16)

      line(79:80)='  '
      titld0(79:80)='  '

!----- Title card,$ 'blank'


c=======================================================================
c     Input parser starts here for file sys.mddata 
c=======================================================================

100   READ(knlist,'(a78)',END=600) line(1:78)
      CALL wrenc(kprint,line)
      IF(line(1:1) .EQ. '#') GOTO 100 
      CALL parse(line,sep,2,comm,strngs,40,nword,iret,errmsg)
      IF(iret.EQ.1) THEN 
         errmsg='while parsing line: toomany strings'
         CALL xerror(errmsg,80,1,30)
         go to 100
      END IF

c=====Environment RUN ==================================================
      IF(strngs(1).EQ. '&RUN' ) THEN
         CALL read_run(fprop,frject,fmaxrun,fmaxstp,fprint,err_args
     &        ,err_unr,err_end)
c=======================================================================

c=====Environment INOUT ================================================
      ELSE IF(strngs(1).EQ. '&INOUT' ) THEN
        CALL read_inout(fconf,fsave,fplot,fplot_fragm,fplot_steer
     &       ,fplottemp_stn0,fplot_stn0,fplot_center,fascii,err_open
     &       ,err_args,err_end,err_unr)
c=======================================================================

c=====Environment SIMULATION============================================
      ELSE IF(strngs(1).EQ. '&SIMULATION' ) THEN
         CALL read_simulation(fscale,err_args,err_unr,err_open,err_end)
c=======================================================================

c=====Environment POTENTIAL=============================================
      ELSE IF(strngs(1).EQ. '&POTENTIAL' ) THEN
         CALL read_potential(fupdte,fabmd,err_args,err_unr,err_end)
c=======================================================================

#ifdef PARALLEL
c=====Environment REM=============================================
      ELSE IF(strngs(1).EQ. '&REM' ) THEN
         CALL read_rem(err_args,err_unr,err_end,err_fnf)
c=======================================================================
#endif

c=====Environment META============================================
      ELSE IF(strngs(1).EQ. '&META' ) THEN
         CALL read_meta(err_args,err_unr,err_end)
c=======================================================================

c=====Environment SETUP=================================================
      ELSE IF(strngs(1).EQ. '&SETUP' ) THEN
         CALL read_setup(err_open,err_args,err_end,err_unr
     &        ,err_fnf)
c=======================================================================

c=====Environment INTEGRATOR============================================
      ELSE IF(strngs(1).EQ. '&INTEGRATOR' ) THEN
         CALL read_integrator(err_args,err_unr,err_end)
c=======================================================================

c=====Environment PARAMETERS============================================
      ELSE IF(strngs(1).EQ. '&PARAMETERS' ) THEN
         CALL read_parameters(iret,errmsg)
         IF(iret .NE. 0) THEN 
            CALL xerror(errmsg,80,1,2)
            STOP
         END IF
c=======================================================================

c=====Environment SOLUTE================================================
      ELSE IF(strngs(1).EQ. '&SOLUTE' ) THEN
         CALL read_solute(err_args,err_unr,err_end,err_fnf,err_open)
c=======================================================================

c=====Environment SOLVENT===============================================
      ELSE IF(strngs(1).EQ. '&SOLVENT' ) THEN
         CALL read_solvent(err_open,err_fnf,err_args,err_unr,err_end)
c=======================================================================

c=====Environment ANALYSIS==============================================
      ELSE IF(strngs(1).EQ. '&ANALYSIS' ) THEN
         CALL read_analysis(err_args,err_unr,err_end)

c=======================================================================

c=====Environment PROPERTIES ===========================================
      ELSE IF(strngs(1).EQ. '&PROPERTIES') THEN
         CALL read_properties(fxrms,favg,favg_xrms,fvi,gofr_fprint
     &        ,fvoronoi,ftop_print,gofr_favg,gofr_fcomp,fprtvaf,ftotvaf
     &        ,fnovaf,fdipole,ffragm_dist,fhbonds,frms,fgyr,err_open
     &        ,err_args,err_unr,err_end)
c=======================================================================

c=====Blank Line =======================================================
      ELSE IF(strngs(1).EQ. ' ' ) THEN
         CONTINUE

c=====Unrecognized Environment==========================================
      ELSE
         errmsg='Unrecognized ENVIRONMENT  ---> '// strngs(1)
         call xerror(errmsg,80,1,2) 
         STOP
      END IF
      
      GOTO 100

*-----------------------------------------------------------------------

600   CONTINUE

      WRITE(kprint,17)
      CALL verify_input(fmaxstp,fscale,fprint,fsave,fplot,fascii
     &     ,fprop,fplot_fragm,fplot_steer,fplottemp_stn0,fplot_stn0
     &     ,fplot_center,frject,fconf,fmaxrun,fupdte,fxrms,fvi,favg
     &     ,favg_xrms,fvoronoi,ftop_print,gofr_fprint,gofr_favg
     &     ,gofr_fcomp,fprtvaf,ftotvaf,fnovaf,fdipole,ffragm_dist
     &     ,fhbonds,frms,fgyr,fabmd,iret,errmsg)

      IF(iret .EQ. 1) CALL xerror(errmsg,80,1,2)

      RETURN
      
*----------------- END OF EXECUTABLE STATEMENTS -----------------------*

1     FORMAT(80('='))
2     FORMAT('=',78x,'=')
3     FORMAT
     x    ('=               oooooo       rrrrrrr        aaaaa    ',
     x     '      ccccccc             ='/
     x     '=             oooooooooo     rrrrrrrr     aaaaaaaaa  ',
     x     '     ccccccccc            ='/
     x     '=            ooo      ooo    rr    rrr    aaa   aaa  ',
     x     '    ccc                   ='/
     x     '=            oo        oo    rr    rr    aaa     aaa ',
     x     '    cc                    ='/
     x     '=            oo        oo    rr rrr      aaaaaaaaaaa ',
     x     '    cc                    ='/
     x     '=            ooo      ooo    rr  rrr     aaaaaaaaaaa ',
     x     '    ccc                   ='/
     x     '=             oooooooooo     rr    rr    aa       aa ',
     x     '     ccccccccc            ='/
     x     '=               oooooo       rr    rrr   aa       aa ',
     x     '      ccccccc             =')
4     FORMAT(
     x'=                              (Release 5)  ',
     x'                                   =')
5     FORMAT(
     x'=     "A Molecular Dynamics Program to Simulate',
     x' Complex Molecular Systems"     =')
6     FORMAT(
     x'=                Copyright(C) 1989 - 2009   ',
     x' M. Marchi and P. Procacci         =')
7     FORMAT(
     x'=                        All Right Reserved',
     x'                                    =')
10    FORMAT(
     x'=   ORAC is provided "as is" and without any',
     x' warranty express or implied.      =',/
     x'=   The user assumes all risks of using ORAC.',
     x'                                  =')
11    FORMAT(
     x'=   The user may make copies of ORAC for his',
     x'/her own use, and modify those     =',/
     x'=   copies. The user MAY distribute any copy of the',
     x' original or modified       =',/
     x'=   source code to any users at any sites',
     x' under the General Public License     =')
12    FORMAT(
     x'=                                                ',
     x'                              =')
13    FORMAT(
     x'=     Chemistry Department, Florence University ',
     x'                               ='/
     x'=               I-50019 Sesto Fiorentino, ITALY',
     x'                                =')
16    FORMAT(
     x     //'=========================== INPUT TO ',
     x     'THE RUN ==================================='/
     x     '=',78(' '),'=')
17    FORMAT('=',78(' '),'='/80('=')//)

      END

#ifdef PARALLEL     
      SUBROUTINE read_rem(err_args,err_unr,err_end,err_fnf)

************************************************************************
*   Time-stamp: <98/03/22 20:53:55 marchi>                             *
*                                                                      *
*                                                                      *
*                                                                      *
*======================================================================*
*                                                                      *
*              Author:  Massimo Marchi                                 *
*              CEA/Centre d'Etudes Saclay, FRANCE                      *
*                                                                      *
*              - Sat Nov 18 1995 -                                     *
*                                                                      *
************************************************************************

*---- This subroutine is part of the program ORAC ----*


*======================== DECLARATIONS ================================*

      IMPLICIT none

*----------------------------- ARGUMENTS ------------------------------*
      
      INTEGER iret
      CHARACTER*37 err_args(3)
      CHARACTER*20 err_end 
      CHARACTER*27 err_unr(4)

*----------------------- VARIABLES IN COMMON --------------------------*
      
      INCLUDE 'parst.h'
      INCLUDE 'cpropar.h'
      INCLUDE 'unit.h'
      INCLUDE 'crem.inc'
      INCLUDE 'mpif.h'

*------------------------- LOCAL VARIABLES ----------------------------*

      INTEGER nword,nsevere,nwarning,j
      CHARACTER*80 errmsg
      CHARACTER*80 line,strngs(40)
      CHARACTER*8 fmt
      CHARACTER*15 err_fnf
      CHARACTER*1 sep(2),comm(2)
      LOGICAL  exist
      DATA sep/' ',','/comm/'(',')'/
      REAL*8 aux
      INTEGER i
      INTEGER nproc,iproc,ierr
      real*8 dum, dum1, dum2, dum3
      CALL MPI_Comm_size(MPI_COMM_WORLD, nproc, ierr)
      CALL MPI_Comm_rank(MPI_COMM_WORLD, iproc, ierr)
      
*----------------------- EXECUTABLE STATEMENTS ------------------------*

      rem_groups = 0
      rem_segkind = 0
      rem_segment = .FALSE.

c=======================================================================
c     Environment parser starts here 
c=======================================================================

      j=0
      nsevere = 0 
      nwarning = 0 
      line(79:80)='  '
100   READ(knlist,'(a78)',END=600) line(1:78)
      CALL wrenc(kprint,line)
      IF(line(1:1) .EQ. '#') GOTO 100 
      CALL parse(line,sep,2,comm,strngs,40,nword,iret,errmsg)
      IF(iret.EQ.1) THEN 
         errmsg='while parsing line: toomany strings'
         CALL xerror(errmsg,80,1,2)
         nsevere = nsevere + 1
         go to 100
      END IF
      
      if(mod(nproc,2).eq.0) rem=.true. !!!! the rem algorithm works only with an even number of replicas
      if(nproc.eq.1) REM=.true.        !!!! or with one replica but no exchanges are attempted

c==== Command  SCALING================================================
      
c read the extremum value of the scaling factor      
      IF(strngs(1).EQ. 'SETUP' ) THEN
        IF((nword.eq.5).or.(nword.eq.3)) THEN 
          IF(nword.eq.5) THEN 
            CALL fndfmt(2,strngs(2),fmt)
            READ(strngs(2),fmt,err=20) rem_factor_max(1)
            CALL fndfmt(2,strngs(3),fmt)
            READ(strngs(3),fmt,err=20) rem_factor_max(2)
            CALL fndfmt(2,strngs(4),fmt)
            READ(strngs(4),fmt,err=20) rem_factor_max(3)
            CALL fndfmt(1,strngs(5),fmt)
            READ(strngs(5),fmt,err=20) cdist
          ELSE                  ! if orac finds only one scaling factor, sets all the scaling factors to that value
            CALL fndfmt(2,strngs(2),fmt) 
            READ(strngs(2),fmt,err=20) rem_factor_max(1)
            CALL fndfmt(1,strngs(3),fmt)
            READ(strngs(3),fmt,err=20) cdist
            rem_factor_max(2) = rem_factor_max(1)
            rem_factor_max(3) = rem_factor_max(1)
          ENDIF
          
        ELSE
          nsevere = nsevere + 1
          errmsg=err_args(3) //'2 or 4'
          CALL xerror(errmsg,80,1,30)
        END IF
        
c==== Command  REMSTEP================================================
        
c read the REM step time 
      ELSEIF(strngs(1).EQ. 'REMSTEP' ) THEN
        IF(nword.eq.2) THEN 
          CALL fndfmt(2,strngs(2),fmt)
          READ(strngs(2),fmt,err=20) rem_ts
        ELSE
          nsevere = nsevere + 1
          errmsg=err_args(3) //'1'
          CALL xerror(errmsg,80,1,30)
        END IF

c==== Command  SEGMENT================================================
        
c read the first and the last atom of the segment
      ELSEIF(strngs(1).EQ. 'SEGMENT' ) THEN
        rem_segment = .TRUE.
c------- read the line
700     READ(knlist,'(a78)',END=600) line(1:78)
        CALL wrenc(kprint,line)
        IF(line(1:1) .EQ. '#') GOTO 700
        CALL parse(line,sep,2,comm,strngs,40,nword,
     x       iret,errmsg)
        IF(strngs(1) .EQ. 'define') THEN
          IF(nword.eq.3) THEN 
            rem_groups = rem_groups + 1
            CALL fndfmt(1,strngs(2),fmt)
            READ(strngs(2),fmt,err=20) rem_group(1,rem_groups)
            CALL fndfmt(1,strngs(3),fmt)
            READ(strngs(3),fmt,err=20) rem_group(2,rem_groups)
          ELSE
            nsevere = nsevere + 1
            errmsg=err_args(3) //'2'
            CALL xerror(errmsg,80,1,30)
          END IF
        ELSEIF(strngs(1) .EQ. 'kind') THEN
          IF(nword.eq.2) THEN 
            IF(strngs(2) .EQ. 'intra') THEN
              rem_segkind = 1
            ELSEIF(strngs(2) .EQ. 'inter') THEN
              rem_segkind = 2
            ENDIF
! do nothing  
          ELSE
            nsevere = nsevere + 1
            errmsg=err_args(3) //'1'
            CALL xerror(errmsg,80,1,30)
          ENDIF
          
        ELSE IF(strngs(1) .EQ. 'defaults') THEN
          CONTINUE
          
        ELSE IF(strngs(1).EQ. ' ') THEN
          CONTINUE
          
        ELSE IF(strngs(1) .EQ. 'END') THEN
          GOTO 100
        ELSE
c---        could not find SUBCOMMAND of END
          errmsg=err_unr(2) // strngs(1)// ' or missing END'
          call xerror(errmsg,80,1,30)
          nsevere = nsevere + 1 
        END IF
        GOTO 700
        
        
c==== Command  PRINT================================================
        
c read the REM print time 
      ELSEIF(strngs(1).EQ. 'PRINT' ) THEN
        IF(nword.eq.2) THEN 
          CALL fndfmt(2,strngs(2),fmt)
          READ(strngs(2),fmt,err=20) rem_print
        ELSE
          nsevere = nsevere + 1
          errmsg=err_args(3) //'1'
          CALL xerror(errmsg,80,1,30)
        END IF

c==== Command BLANK LINE===============================================
        
      ELSE IF(strngs(1).EQ. ' ') THEN
         GOTO 100
c==== Begininning of next ENVIRONMENT =================================

      ELSE IF(strngs(1)(1:1).EQ. '&'.AND.strngs(1).NE. '&END') THEN
         errmsg= err_unr(1) // strngs(1)(1:8) // err_end
         CALL xerror(errmsg,80,1,30)
         nsevere = nsevere + 1
         GO TO 600

c==== Command &END ====================================================

      ELSE IF(strngs(1).EQ. '&END') THEN
         GOTO 600
         
      ELSE
         errmsg= err_unr(1) // strngs(1)(1:8) // err_end
         CALL xerror(errmsg,80,1,30)
         nsevere = nsevere + 1
      END IF

      GO TO 100

600   CONTINUE

c=======================================================================
c     Environment parser ends here 
c=======================================================================

c--   syntax errors: abort without verifying input 
      if(nsevere.gt.0.and.nsevere.lt.99) then 
         call int_str(nsevere,fmt,j)
         errmsg=fmt(1:j) //' ERRORS WHILE EXECUTING READ_REM'
         call xerror(errmsg,80,1,2)
         call MPI_BARRIER(MPI_COMM_WORLD,ierr) 
         call MPI_FINALIZE(ierr)
         STOP
      ELSE IF(nsevere.gt.99) THEN 
         errmsg= 'MORE THAN 99 ERRORS WHILE EXECUTING READ_REM'
         call xerror(errmsg,80,1,2)
         call MPI_BARRIER(MPI_COMM_WORLD,ierr) 
         call MPI_FINALIZE(ierr)
         STOP
      END IF
      if(nwarning.gt.0.and.nwarning.lt.99) then 
         j=0
         call int_str(nwarning,fmt,j)
         errmsg= fmt(1:j)//' WARNINGS WHILE EXECUTING READ_REM'
         CALL xerror(errmsg,80,1,1)
      ELSE IF(nwarning.gt.99) THEN 
         errmsg= 'MORE THAN 99 WARNINGS WHILE EXECUTING READ_REM'
         call xerror(errmsg,80,1,1)
      ENDIF    
      
      RETURN

c==============================================================================
c     Errors were found
c==============================================================================


 20   CONTINUE
      iret=1
      errmsg='internal reading error: wrong format?? TAB character?? '
      CALL xerror(errmsg,80,1,2)
      call MPI_BARRIER(MPI_COMM_WORLD,ierr) 
      call MPI_FINALIZE(ierr)
      STOP

*----------------- END OF EXECUTABLE STATEMENTS -----------------------*

      END
#endif
