      SUBROUTINE iterative(nrep,np,rep,psi,n,b,e)
      IMPLICIT NONE
      INCLUDE 'dim.inc'
      INCLUDE 'const.inc'
      INTEGER np,nrep
      INTEGER n(rmax)
      INTEGER rep(pmax)
      REAL(16) psi(rmax), exp_psi(rmax),b(rmax)
      REAL(16) e(pmax)
! local
      INTEGER iter,p,irep,rp
      REAL(16) sum,dpi,zero,diff
      REAL(16) psi0(rmax)
      REAL(16) d(pmax),w(pmax)
      LOGICAL conv

      
      DO irep = 1,nrep
        n(irep) = 0
        psi0(irep) = psi(irep)
      ENDDO
      
      DO p = 1,np
        rp = rep(p)
        n(rp) = n(rp) + 1
      ENDDO
      
      
      DO iter = 1,niter
        
        DO irep = 1,nrep
          exp_psi(irep) = EXP(psi(irep))
        ENDDO
        
        DO p = 1,np ! calculate the vector d(p)
          sum = 0.
          DO irep = 1,nrep
            sum = sum + exp_psi(irep) * EXP(-b(irep) * e(p)) * n(irep)
          ENDDO
          d(p) = sum
        ENDDO         
        
        DO irep = 1,nrep
          DO p = 1,np ! calculate the vector of weights for replica irep
            w(p) = EXP(-b(irep) * e(p)) / d(p)
          ENDDO
          sum = 0.
          DO p = np,1,-1
            sum = sum + w(p)
          ENDDO
          IF(irep .EQ.1) zero = - LOG(sum)
          psi(irep) = - LOG(sum) - zero ! PSI(1) IS CONSTRAINED TO ZERO AT THE END OF EACH ITERATION
        ENDDO

        WRITE(0,*) 'Step n: ', iter, ' psi ', psi(nrep)

        conv = .true.
        DO irep = 2,nrep        ! IF THE DIFFERENCE BETWEEN THE NEW AND THE OLD VALUE OF EACH ELEMENT OF THE PSI ARRAY IS SMALLER THAN A THRESHOLD THE ALGORITHM HAS CONVERGED
          diff = psi(irep) - psi0(irep)
          if(abs(diff).gt.eps) conv=.FALSE.
          psi0(irep) = psi(irep)
        ENDDO
        
        IF(conv) GOTO 1000      ! IF THE ALGORITHM HAS CONVERGED, EXIT FROM THE ITERATIVE LOOP
        
      ENDDO
      
1000  CONTINUE
      
      RETURN
      END
      

