      SUBROUTINE plotmtv_histog(np,w,cv,rep,fes_unit ! rimettere a posto
     &     ,fes_mbar_unit) 
      IMPLICIT NONE
      INCLUDE 'dim.inc'
      INCLUDE 'const.inc'
      INTEGER  np,fes_unit,fes_mbar_unit
      INTEGER  rep(pmax)
      REAL(16) b0
      REAL(16) w(pmax)
      REAL(16) cv(2,pmax)
! local
      REAL(16) dx,hmax,xx,fmax,h2max
      REAL(16) h(0:nchan,0:nchan),f(0:nchan,0:nchan),h2(0:nchan,0:nchan)
     &     ,f2(0:nchan,0:nchan)
      INTEGER  i,j,p,chan1,chan2,ierror

      b0 = 1. / (gascon * 0.001 * t0)
      
      dx = (x2 - x1) / (nchan*1.)
      hmax = -100000.
      h2max = -100000.
      fmax = 50.
      
      DO i = 0,nchan
        DO j = 0,nchan
          h(i,j) = 0.
          h2(i,j) = 0.
          f(i,j) = 0.
          f2(i,j) = 0.
        ENDDO
      ENDDO
      
      DO p = 1,np
        xx = cv(1,p) - x1
        chan1 = NINT(xx/dx)
        xx = cv(2,p) - x1
        chan2 = NINT(xx/dx)
        h(chan1,chan2) = h(chan1,chan2) + w(p)
        IF(rep(p).EQ.1) h2(chan1,chan2) = h2(chan1,chan2) + 1.
        IF(h(chan1,chan2).GT.hmax) hmax = h(chan1,chan2)
        IF(h2(chan1,chan2).GT.h2max) h2max = h2(chan1,chan2)
      ENDDO
      
      hmax = - LOG(hmax) / b0
      h2max = - LOG(h2max) / b0
      
      DO i = 0,nchan
        DO j = 0,nchan

          IF(i.EQ.0) THEN 
            h(0,j) = h(0,j) + h(nchan,j)
            h(nchan,j) = h(0,j) 
            h2(0,j) = h2(0,j) + h2(nchan,j)
            h2(nchan,j) = h2(0,j) 
          ENDIF

          IF(j.EQ.0) THEN 
            h(i,0) = h(i,0) + h(i,nchan)
            h(i,nchan) = h(i,0) 
            h2(i,0) = h2(i,0) + h2(i,nchan)
            h2(i,nchan) = h2(i,0) 
          ENDIF

          IF(h(i,j).GT.0.) THEN 
            f(i,j) = - LOG(h(i,j)) / b0 - hmax
            IF(f(i,j).GT.fmax) f(i,j) = fmax
          ELSE
            f(i,j) = fmax
          ENDIF
          
          IF(h2(i,j).GT.0.) THEN 
            f2(i,j) = - LOG(h2(i,j)) / b0 - h2max
            IF(f2(i,j).GT.fmax) f2(i,j) = fmax
          ELSE
            f2(i,j) = fmax
          ENDIF

        ENDDO
      ENDDO
      
      
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      
      write(fes_mbar_unit,*) '$ DATA=CONTOUR name=" "'
      write(fes_mbar_unit,11) x1,x2,nchan+1
      write(fes_mbar_unit,12) x1,x2,nchan+1
      write(fes_mbar_unit,*) '%contstyle=2'
      write(fes_mbar_unit,*) '%nsteps =50'
      
      write(fes_mbar_unit,*) '%cmax=', fmax
      write(fes_mbar_unit,*) '%cmin=', 0.
      write(fes_mbar_unit,*) '%vxmin=', x1
      write(fes_mbar_unit,*) '%vxmax=', x2
      write(fes_mbar_unit,*) '%vymin=', x1
      write(fes_mbar_unit,*) '%vymax=', x2
      write(fes_mbar_unit,*) '% interp     = 2'
      
      do j=0,nchan
        write(fes_mbar_unit,*) (f(i,j),i=0,nchan)
      enddo

      write(fes_unit,*) '$ DATA=CONTOUR name=" "'
      write(fes_unit,11) x1,x2,nchan+1
      write(fes_unit,12) x1,x2,nchan+1
      write(fes_unit,*) '%contstyle=2'
      write(fes_unit,*) '%nsteps =50'
      
      write(fes_unit,*) '%cmax=', fmax
      write(fes_unit,*) '%cmin=', 0.
      write(fes_unit,*) '%vxmin=', x1
      write(fes_unit,*) '%vxmax=', x2
      write(fes_unit,*) '%vymin=', x1
      write(fes_unit,*) '%vymax=', x2
      write(fes_unit,*) '% interp     = 2'
      
      do j=0,nchan
        write(fes_unit,*) (f2(i,j),i=0,nchan)
      enddo

11    format('% YMIN =',f12.5,' YMAX =',f12.5,' NY = ',i4)
12    format('% XMIN =',f12.5,' XMAX =',f12.5,' NX = ',i4)
      
      
      
      END 
      
